<div class="list-input-container">
  <ng-container [formGroup]="list">
    <ul *ngIf='list.controls.length > 0 else placeholder' cdkDropList (cdkDropListDropped)="drop($event)">
      <ng-container *ngIf='!ingredientMode else ingredientRow'>
        <li *ngFor="let row of list.controls; let i = index; trackBy: trackByIndex" cdkDrag>
          <ng-container [formGroup]="row">
            <ng-container [formGroup]="row?.get('attributes')">
              <ng-miam-icon primaryColor="var(--m-color-grey-text-dark)" class="grip" [width]="32" [height]="32"
                [iconName]="icon.Grip" cdkDragHandle></ng-miam-icon>
              <textarea matInput cdkTextareaAutosize='true' #autosize="cdkTextareaAutosize" (blur)='checkRow(i)'
                cdkAutosizeMinRows="1" cdkAutosizeMaxRows="50"
                formControlName='description'></textarea>
              <ng-miam-icon class="clear" (click)="delete(i)" primaryColor="var(--m-color-grey-text-dark)" [width]="32"
                [height]="32" [iconName]="icon.Clear"></ng-miam-icon>
              <div class="row-placeholder" *cdkDragPlaceholder></div>
              <div class="preview-container" *cdkDragPreview>
                <ng-miam-icon primaryColor="var(--m-color-grey-text-dark)" class="grip" [width]="32" [height]="32"
                  [iconName]="icon.Grip" cdkDragHandle></ng-miam-icon>
                <span>{{row?.get('attributes')?.get('description').value}}</span>
                <ng-miam-icon class="clear" (click)="delete(i)" primaryColor="var(--m-color-grey-text-dark)"
                  [width]="32" [height]="32" [iconName]="icon.Clear"></ng-miam-icon>
              </div>
            </ng-container>
          </ng-container>
        </li>
      </ng-container>
      <ng-template #ingredientRow>
        <ng-container *ngFor="let row of list.controls; let i = index; trackBy: trackByIndex">
          <li class="ingredient-row" (cdkDragStarted)='drag()' cdkDrag>
            <div [formGroupName]="i">
              <ng-miam-icon primaryColor="var(--m-color-grey-text-dark)" class="grip" [width]="32" [height]="32"
                [iconName]="icon.Grip" cdkDragHandle></ng-miam-icon>
              <textarea matInput cdkTextareaAutosize='true' class="small-input" #autosize="cdkTextareaAutosize"
                cdkAutosizeMinRows="1" cdkAutosizeMaxRows="50"
                [formControl]="row['controls']['attributes']['controls']['quantity']"></textarea>
              <textarea matInput cdkTextareaAutosize='true' class="medium-input" #autosize="cdkTextareaAutosize"
                cdkAutosizeMinRows="1" cdkAutosizeMaxRows="50"
                [formControl]="row['controls']['attributes']['controls']['unit']"></textarea>
              <textarea matInput cdkTextareaAutosize='true'
                [ngClass]="{'warnning': row?.get('attributes')['isNotReviewedIngredientName'], 'error': row?.get('attributes')?.get('name').invalid}"
                #autosize="cdkTextareaAutosize" cdkAutosizeMinRows="1" cdkAutosizeMaxRows="50" class="medium-input"
                [formControl]="row['controls']['attributes']['controls']['name']"
                (keyup)="checkIngredientdef(row?.get('attributes')?.get('name').value, i)"></textarea>
              <ng-miam-icon class="clear" (click)="delete(i)" primaryColor="var(--m-color-grey-text-dark)" [width]="32"
                [height]="32" [iconName]="icon.Clear"></ng-miam-icon>
              <div class="row-placeholder" *cdkDragPlaceholder></div>
              <div class="preview-container" *cdkDragPreview>
                <ng-miam-icon primaryColor="var(--m-color-grey-text-dark)" class="grip" [width]="32" [height]="32"
                  [iconName]="icon.Grip" cdkDragHandle></ng-miam-icon>
                <span class="medium-input">{{row?.get('attributes')?.get('name').value}}</span>
                <span class="medium-input">{{row?.get('attributes')?.get('quantity').value}}</span>
                <span class="small-input">{{row?.get('attributes')?.get('unit').value}}</span>
                <ng-miam-icon class="clear" (click)="delete(i)" primaryColor="var(--m-color-grey-text-dark)"
                  [width]="32" [height]="32" [iconName]="icon.Clear"></ng-miam-icon>
              </div>
            </div>
            <span *ngIf="row?.get('attributes')['isNotReviewedIngredientName'] && !row.invalid && !hideErrors"
              class="hint warnning">Nous
              ne connaissons pas encore cet
              ingrédient</span>
            <span *ngIf="row.invalid && !hideErrors" class="hint error">Le nom de l'ingrédient ne peut pas être
              vide</span>
          </li>
        </ng-container>
      </ng-template>
    </ul>
  </ng-container>
  <ng-template #placeholder>
    <div class="placeholder-container">
      <span>{{ hint }}</span>
      <ng-miam-icon primaryColor="var(--m-color-grey-text-dark)" [width]="60" [height]="60" [iconName]="icon.ArrowDown">
      </ng-miam-icon>
    </div>
  </ng-template>
  <div class="action-container">
    <textarea matInput class="main-input" cdkTextareaAutosize  cdkAutosizeMinRows="4"
      cdkAutosizeMaxRows="4" (keydown.enter)='mousseDownOnButton = true' (keyup.enter)="submit()"
      [formControl]="fillListInput"></textarea>
    <button class="add-button" (mousedown)='mousseDownOnButton = true' (mouseup)="submit()">
      <ng-miam-icon [ngClass]="{'buttonClick': mousseDownOnButton}" primaryColor="#fff" class="grip"
        [width]="32" [height]="32" [iconName]="icon.ReturnLeft">
      </ng-miam-icon>
    </button>
  </div>
</div>